现在的位置: 首页 > 综合 > 正文

hdu 1159 Common Subsequence

2013年02月08日 ⁄ 综合 ⁄ 共 1544字 ⁄ 字号 评论关闭
Common Subsequence

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other)
Total Submission(s) : 29   Accepted Submission(s) : 16
Problem Description
A subsequence of a given sequence is the given sequence with some elements (possible none) left out. Given a sequence X = <x1, x2, ..., xm> another sequence Z = <z1, z2, ..., zk> is a subsequence of X if there exists a strictly increasing
sequence <i1, i2, ..., ik> of indices of X such that for all j = 1,2,...,k, xij = zj. For example, Z = <a, b, f, c> is a subsequence of X = <a, b, c, f, b, c> with index sequence <1, 2, 4, 6>. Given two sequences X and Y the problem is to find the length of
the maximum-length common subsequence of X and Y.
The program input is from a text file. Each data set in the file contains two strings representing the given sequences. The sequences are separated by any number of white spaces. The input data are correct. For each set of data the program prints on the standard
output the length of the maximum-length common subsequence from the beginning of a separate line.
 

Sample Input
abcfbc abfcab
programming contest
abcd mnp
 

Sample Output
4
2
0
 

题意:求两个串的最长公共子序列

用f [ i ][ j ]表示处理到字符串A的第 i 位 和 字符串B第 j 位时的最大值。
状态转移方程如下:
f [ i ][ j ] = f[ i - 1 ][ j - 1 ] + 1  (A[ i ] == B[ j ])
f [ i ][ j ] = max( f[ i - 1 ][ j ], f [ i ][ j - 1] )    (A[ i ] != B[ j ])

由于每次循环计算只和上一行状态有关,所以可以用循环数组压缩空间

和背包中的一样哦

#include<stdio.h>
#include<string.h>
char a[1000],b[1000];
int dp[1000][1000];
int d1,d2;
int main()
{
    
    int i,j;
    while(scanf("%s",a+1)!=EOF)
    {
        scanf("%s",b+1);
         d1=strlen(a+1);
         d2=strlen(b+1);
         for(i=0;i<=d1;i++)
             dp[i][0]=0;
         for(j=0;j<=d2;j++)
             dp[0][j]=0;
         for(i=1;i<=d1;i++)
         {
             for(j=1;j<=d2;j++)
                 if(a[i]==b[j]) dp[i][j]=dp[i-1][j-1]+1;
                 else 
                 {
                     dp[i][j]=dp[i-1][j]>dp[i][j-1]?dp[i-1][j]:dp[i][j-1];
                 }
         }
              printf("%d\n",dp[d1][d2]);

    }
    return 0;
}

 



抱歉!评论已关闭.